Name:           fftw
Version:        3.2alpha3
Release:        1
Summary:        Fast Fourier Transform library

Group:          System Environment/Libraries
License:        GPL
URL:            http://www.fftw.org/
Source0:        ftp://ftp.fftw.org/pub/fftw/%{name}-%{version}.tar.gz
Patch0:         %{name}-%{version}-aix.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

Requires:	/sbin/install-info
Requires:	info

Provides:       fftw3 = %{version}-%{release}
Obsoletes:      fftw3 < 3.1

%description
FFTW is a C subroutine library for computing the Discrete Fourier
Transform (DFT) in one or more dimensions, of both real and complex
data, and of arbitrary input size.


%package        devel
Summary:        Headers, libraries and docs for the FFTW library
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release} pkg-config

Provides:       fftw3-devel = %{version}-%{release}
Obsoletes:      fftw3-devel < 3.1


%description    devel
FFTW is a C subroutine library for computing the Discrete Fourier
Transform (DFT) in one or more dimensions, of both real and complex
data, and of arbitrary input size.

This package contains header files and development libraries needed to
develop programs using the FFTW fast Fourier transform library.


%prep
%setup -q -c %{name}-%{version}
%patch0 -p0
mv %{name}-%{version} single
cp -pr single double
cp -pr single long


%build
CONFIG_FLAGS="--prefix=%{_prefix} --mandir=%{_prefix}/man --infodir=%{_prefix}/info --enable-shared --disable-dependency-tracking --enable-threads"

# setup environment for 32-bit and 64-bit builds
export AR="ar -X32_64"
export NM="nm -X32_64"

# first build the 64-bit version
export CC="xlc_r -q64"
export CXX="xlC_r -q64"
export F77="xlf_r -q64"

cd double
    ./configure $CONFIG_FLAGS
    make %{?_smp_mflags}
    cp .libs/libfftw3.so.3 .
    cp threads/.libs/libfftw3_threads.so.3 .
    make distclean
cd ..
cd single
    ./configure $CONFIG_FLAGS --enable-single
    make %{?_smp_mflags}
    cp .libs/libfftw3f.so.3 .
    cp threads/.libs/libfftw3f_threads.so.3 .
    make distclean
cd ..
cd long
    ./configure $CONFIG_FLAGS --enable-long-double
    make %{?_smp_mflags}
    cp .libs/libfftw3l.so.3 .
    cp threads/.libs/libfftw3l_threads.so.3 .
    make distclean
cd ..

# now build the 32-bit version
export CC="xlc_r"
export CXX="xlC_r"
export F77="xlf_r"

cd double
    ./configure $CONFIG_FLAGS
    make %{?_smp_mflags}
    ${AR} -q .libs/libfftw3.a ./libfftw3.so.3
    ${AR} -q threads/.libs/libfftw3_threads.a ./libfftw3_threads.so.3
cd ..
cd single
    ./configure $CONFIG_FLAGS --enable-single
    make %{?_smp_mflags}
    ${AR} -q .libs/libfftw3f.a ./libfftw3f.so.3
    ${AR} -q threads/.libs/libfftw3f_threads.a ./libfftw3f_threads.so.3
cd ..
cd long
    ./configure $CONFIG_FLAGS --enable-long-double
    make %{?_smp_mflags}
    ${AR} -q .libs/libfftw3l.a ./libfftw3l.so.3
    ${AR} -q threads/.libs/libfftw3l_threads.a ./libfftw3l_threads.so.3
cd ..


%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
cd double
    make install DESTDIR=${RPM_BUILD_ROOT}
    cp -pr AUTHORS COPYING COPYRIGHT ChangeLog NEWS README* TODO ../
    cp -pr doc/ ../
cd ..
cd single
    make install DESTDIR=${RPM_BUILD_ROOT}
cd ..
cd long
    make install DESTDIR=${RPM_BUILD_ROOT}
cd ..

gzip --best $RPM_BUILD_ROOT%{_infodir}/*.info


%clean
###[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT


%post devel
/sbin/install-info --section="Math" %{_infodir}/%{name}.info.gz %{_infodir}/dir  2>/dev/null || :

%preun devel
if [ "$1" = 0 ]; then
    /sbin/install-info --delete %{_infodir}/%{name}.info.gz %{_infodir}/dir 2>/dev/null || :
fi


%files
%defattr(-,root,system,-)
%doc AUTHORS COPYING COPYRIGHT ChangeLog NEWS README* TODO
%{_bindir}/*
%{_libdir}/*.a
%{_mandir}/man?/*

%files devel
%defattr(-,root,system,-)
%doc doc/html/*
%{_includedir}/*
%{_libdir}/*.la
%{_libdir}/pkgconfig/*

%changelog
* Fri Mar 14 2008 Michael Perzl <michael@perzl.org> - 3.2alpha3-1
- updated to version 3.2alpha3

* Thu Jan 31 2008 Michael Perzl <michael@perzl.org> - 3.1.2-1
- First version for AIX5L v5.1 and higher
